<?php
/**
 *     File: horde/admin/custom_imp_users.php v1.0
 *  Created: 2002/04/11
 * Modified: 2002/04/14
 * See http://vkinetic.com/hordedev for current version and information.
 *
 * Copyright 2002 Ben Gerber <ben@vkinetic.com>
 * See http://www.fsf.org/copyleft/gpl.html for license information (GPL).
 *
 *
 * See imp/_custom/imp_sql_auth.php for table structure information.
 *
 *
 * imp/_custom/key.php contains the secret key for encoding/decoding the stored pop/imap passwords
 *
 *
 * Place this line of code in
 * horde/templates/admin/index/admin.inc (revision 1.2)
 * (available via cvs.horde.org, not in distribution of Horde 2.0;
 *  you will also need horde/admin/index.php):
 * ___
 * <?= Horde::link(Horde::applicationUrl('admin/custom_imp_users.php'), _("Custom - IMP Users"), 'menuitem') . Horde::img('user.gif') . '&nbsp;' . _("Custom - IMP Users") ?></a><br />
 * ___
 *
 */

// set these
$_custom_db_name = 'horde';
$_custom_db_host = 'localhost';
$_custom_db_user = 'horde';
$_custom_db_pass = '*****';
$path_to_key     = '../imp/_custom';   // path to key.php

// only allow admin users (code from horde/admin/user.php,v 1.3.2.2 2002/01/02)
require_once '../lib/base.php';

if (!@is_array($conf['auth']['admins'])) {
    exit('there are no administrators. user administration is disabled.');
}

if (!Auth::getAuth() || !in_array(Auth::getAuth(), $conf['auth']['admins'])) {
    exit('forbidden.');
}
// -------

$_custom_db = mysql_connect($_custom_db_host, $_custom_db_user, $_custom_db_pass);
mysql_select_db($_custom_db_name, $_custom_db);

?>
<html>
<!-- Custom Horde/IMP code: http://vkinetic.com/hordedev -->
<!-- Horde Project: http://horde.org/ | IMP: http://horde.org/imp/ -->
<head>
    <title>Manage IMP Users</title>
    <script type="text/javascript">
    <!--
        function setSubmitValues() {

            var n = getRadioValue(document.impUsers.rowIndex);

            if (n == -1) { // insert

                if (document.impUsers.zhorde_user_uid.value == "") {

                    alert("Please enter horde_user_uid for insert");
                    document.impUsers.zhorde_user_uid.focus();
                    return false;

                } else if (document.impUsers.zimp_imapuser.value == "") {

                    alert("Please enter imp_imapuser for insert");
                    document.impUsers.zimp_imapuser.focus();
                    return false;

                } else if (document.impUsers.zimp_pass.value == "") {

                    alert("Please enter imp_pass for insert");
                    document.impUsers.zimp_pass.focus();
                    return false;

                } else if (document.impUsers.zimp_server.value == "") {

                    alert("Please enter imp_server for insert");
                    document.impUsers.zimp_server.focus();
                    return false;

                }

                document.impUsers.horde_user_uid.value = document.impUsers.zhorde_user_uid.value;
                document.impUsers.imp_imapuser.value   = document.impUsers.zimp_imapuser.value;
                document.impUsers.imp_pass.value       = document.impUsers.zimp_pass.value;
                document.impUsers.imp_server.value     = document.impUsers.zimp_server.value;
                document.impUsers.enabled.value        =
                document.impUsers.zenabled.options[document.impUsers.zenabled.selectedIndex].value;
                document.impUsers.transaction.value    = 'insert';
                document.impUsers.promptMessage.value  = 'Insert new record?';

            } else { // update

                if (document.impUsers.xhorde_user_uid[n].value == "") {

                    alert("Please enter horde_user_uid for update of record with row id " +
                    document.impUsers.xid[n].value);
                    document.impUsers.xhorde_user_uid[n].focus();
                    return false;

                } else if (document.impUsers.ximp_imapuser[n].value == "") {

                    alert("Please enter imp_imapuser for update of record with row id " +
                    document.impUsers.xid[n].value);
                    document.impUsers.ximp_imapuser[n].focus();
                    return false;

                } else if (document.impUsers.ximp_pass[n].value == "") {

                    alert("Please enter imp_pass for update of record with row id " +
                    document.impUsers.xid[n].value);
                    document.impUsers.ximp_pass[n].focus();
                    return false;

                } else if (document.impUsers.ximp_server[n].value == "") {

                    alert("Please enter imp_server for update of record with row id " +
                    document.impUsers.xid[n].value);
                    document.impUsers.ximp_server[n].focus();
                    return false;

                }

                document.impUsers.id.value             = document.impUsers.xid[n].value;
                document.impUsers.horde_user_uid.value = document.impUsers.xhorde_user_uid[n].value;
                document.impUsers.imp_imapuser.value   = document.impUsers.ximp_imapuser[n].value;
                document.impUsers.imp_pass.value       = document.impUsers.ximp_pass[n].value;
                document.impUsers.imp_server.value     = document.impUsers.ximp_server[n].value;
                document.impUsers.enabled.value        =
                document.impUsers.xenabled[n].options[document.impUsers.xenabled[n].selectedIndex].value;
                document.impUsers.transaction.value    = 'update';
                document.impUsers.promptMessage.value  = 'Update the record with row id ' +
                document.impUsers.id.value + '?';

            }

            return confirm(document.impUsers.promptMessage.value);
        
        }


        function getRadioValue(radioObject) {
            var rvalue = null;
            for (var i=0; i < radioObject.length; i++) {
                if (radioObject[i].checked) {
                    rvalue = radioObject[i].value;
                    break;
                }
            }
            return rvalue;
        }
    // -->
    </script>
</head>
<body>

<?php

if (!isset($transaction)) {
    $transaction = 'list';
}

if ($transaction == 'list') {

    $result = mysql_query("SELECT
                           id,
                           horde_user_uid,
                           imp_imapuser,
                           imp_server,
                           enabled,
                           last_updated
                           FROM custom_imp_users
                           ORDER BY id",
                           $_custom_db);

    printf ('<form action="%s" name="impUsers" method="post">', $REQUEST_URI);
    echo '<b>Custom IMP Users</b><br><table border="1">' .
    '<tr><td>&nbsp;</td><td><b>id</b></td><td><b>horde_user_uid</b></td>' .
    '<td><b>imp_imapuser</b></td><td><b>imp_pass</b></td>' .
    '<td><b>imp_server</b></td><td><b>enabled</b></td>' .
    '<td><b>last_updated</b></td><td>&nbsp;</td></tr>';

    $rowIndex = 0;
    while ($myrow = mysql_fetch_array($result)) {

        $isNotEnabled = '';
        if ($myrow['enabled'] != 1) {
            $isNotEnabled = 'selected';
        }

        printf(
        '<tr><td><input type="radio" name="rowIndex" value="%s"></td>' .
        '<td>%s<input type="hidden" name="xid" value="%s"></td>' .
        '<td><input type="text" name="xhorde_user_uid" value="%s" maxlength="255" size="11"></td>' .
        '<td><input type="text" name="ximp_imapuser" value="%s" maxlength="20"  size="11"></td>' .
        '<td><input type="password" name="ximp_pass" size="11"></td>' .
        '<td><input type="text" name="ximp_server" value="%s" maxlength="20"  size="11"></td>' .
        '<td><select name="xenabled" size="1">' .
        '<option value="1">y</option>' .
        '<option value="-1" %s>n</option></select></td>' .
        '<td>%s</td>' .
        '<td><input type="submit" name="delete" value="delete" onClick="' .
        'impUsers.id.value = %s; impUsers.transaction.value  = \'delete\'; ' .
        'return confirm(\'Delete the record with row id %s?\');' .
        '"></td></tr>',

        $rowIndex,$myrow['id'],$myrow['id'],$myrow['horde_user_uid'],$myrow['imp_imapuser'],
        $myrow['imp_server'],$isNotEnabled,$myrow['last_updated'],
        $myrow['id'],$myrow['id']
        );

        $rowIndex = $rowIndex + 1;

    }

    // row for insert
    echo
    '<tr><td colspan="9" align="center"><br>all fields are required for an update or insert<p></td></tr>' .
    '<tr><td><input type="radio" name="rowIndex" value="-1" checked></td>' .
    '<td>&nbsp;</td>' .
    '<td><input type="text" name="zhorde_user_uid" maxlength="255" size="11"></td>' .
    '<td><input type="text" name="zimp_imapuser" maxlength="20"  size="11"></td>' .
    '<td><input type="password" name="zimp_pass" size="11"></td>' .
    '<td><input type="text" name="zimp_server" maxlength="20"  size="11"></td>' .
    '<td><select name="zenabled" size="1">' .
    '<option value="1">y</option>' .
    '<option value="-1">n</option></select></td>' .
    '<td>&nbsp;&nbsp;new</td>' .
    '<td>&nbsp;</td></tr>';

    // hidden values and submit button
    echo
    '<tr><td colspan="9" align="center">' .
    '<input type="hidden" name="rowIndex" value="">' .
    '<input type="hidden" name="xid" value="">' .
    '<input type="hidden" name="xhorde_user_uid" value="">' .
    '<input type="hidden" name="ximp_imapuser" value="">' .
    '<input type="hidden" name="ximp_pass" value="">' .
    '<input type="hidden" name="ximp_server" value="">' .
    '<input type="hidden" name="xenabled" value="">' .
    '<input type="submit" name="submit" value="update / insert selected row" onClick="return setSubmitValues()">' .
    '<input type="hidden" name="id" value="">' .
    '<input type="hidden" name="horde_user_uid" value="">' .
    '<input type="hidden" name="imp_imapuser" value="">' .
    '<input type="hidden" name="imp_pass" value="">' .
    '<input type="hidden" name="imp_server" value="">' .
    '<input type="hidden" name="enabled" value="">' .
    '<input type="hidden" name="transaction" value="list">' .
    '<input type="hidden" name="promptMessage" value="error">' .
    '</td></tr>';

    echo '</table></form>';

} else if ($transaction == 'update') {

    if ((empty($_POST['id']))             ||
        (empty($_POST['horde_user_uid'])) ||
        (empty($_POST['imp_imapuser']))   ||
        (empty($_POST['imp_pass']))       ||
        (empty($_POST['imp_server']))     ||
        (empty($_POST['enabled']))) {

        echo 'Error: data is missing <p> Transaction: update';

    } else {

        require_once $path_to_key . '/key.php';

        $result = mysql_query("UPDATE custom_imp_users SET                                   
                               horde_user_uid = '$horde_user_uid',
                               imp_imapuser = '$imp_imapuser',
                               imp_pass = encode('$imp_pass', '$_custom_key'),
                               imp_server = '$imp_server',
                               enabled = '$enabled'
                               WHERE id = '$id'",
                               $_custom_db);
    
    }

} else if ($transaction == 'insert') {

    if ((empty($_POST['horde_user_uid'])) ||
        (empty($_POST['imp_imapuser']))   ||
        (empty($_POST['imp_pass']))       ||
        (empty($_POST['imp_server']))     ||
        (empty($_POST['enabled']))) {

        echo 'Error: data is missing <p> Transaction: insert';

    } else {

        require_once $path_to_key . '/key.php';

        $result = mysql_query("INSERT into custom_imp_users VALUES (
                               null,
                               '$horde_user_uid',
                               '$imp_imapuser',
                               encode('$imp_pass', '$_custom_key'),
                               '$imp_server',
                               '$enabled',
                               null)",
                               $_custom_db);

    }

} else if ($transaction == 'delete') {

    if (empty($_POST['id'])) {

        echo 'Error: data is missing <p> Transaction: delete';
    
    } else {

        $result = mysql_query("DELETE FROM custom_imp_users
                               WHERE id = '$id'",
                               $_custom_db);

    }

} else {

    echo 'Error: invalid transaction';

}

if ($transaction != 'list') {
    printf('<p>&nbsp;&nbsp;&nbsp;<a href="%s">Return to listing of IMP users</a>',
    Horde::applicationUrl('admin/custom_imp_users.php'));
}

printf('<p>&nbsp;&nbsp;&nbsp;<a href="%s">Return to Horde Administration</a>',
Horde::applicationUrl('admin/'));

?>

</body>
</html>